<?php
/*
Dragon Go Server
Copyright (C) 2001-2007  Erik Ouchterlony, Rod Ival

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

$TranslateGroups[] = "Countries";

// Table of: ISO 3166 code => country name
//     (plus some international languages (ISO 639 code))

//some flags sites:
// https://www.cia.gov/cia/publications/factbook/
// http://setiathome.free.fr/images/flags/iso3166-1.html
//plus some international languages (ISO 639 code):
// http://www.oasis-open.org/cover/iso639a.html
// http://www.loc.gov/standards/iso639-2/langcodes.html

// The $T_ are required for 'scripts/generate_translation_texts.php'.
$T_ = 'fnop';

$COUNTRIES = array(
   'af' => $T_('Afghanistan'),
   'al' => $T_('Albania'),
   'dz' => $T_('Algeria'),
   'ad' => $T_('Andorra'),
   'ao' => $T_('Angola'),
   'aq' => $T_('Antarctica'),
   'ag' => $T_('Antigua And Barbuda'),
   'ar' => $T_('Argentina'),
   'am' => $T_('Armenia'),
   'au' => $T_('Australia'),
   'at' => $T_('Austria'),
   'az' => $T_('Azerbaijan'),
   'bs' => $T_('Bahamas'),
   'bh' => $T_('Bahrain'),
   'bb' => $T_('Barbados'),
   'bd' => $T_('Bangladesh'),
   'by' => $T_('Belarus'),
   'be' => $T_('Belgium'),
   'bz' => $T_('Belize'),
   'bj' => $T_('Benin'),
   'bt' => $T_('Bhutan'),
   'bo' => $T_('Bolivia'),
   'ba' => $T_('Bosnia and Herzegowina'),
   'bw' => $T_('Botswana'),
   'br' => $T_('Brazil'),
   'bn' => $T_('Brunei'),
   'bg' => $T_('Bulgaria'),
   'bf' => $T_('Burkina Faso'),
   'bi' => $T_('Burundi'),
   'kh' => $T_('Cambodia'),
   'cm' => $T_('Cameroon'),
   'ca' => $T_('Canada'),
   'cv' => $T_('Cape Verde'),
   'cf' => $T_('Central African Republic'),
   'td' => $T_('Chad'),
   'cl' => $T_('Chile'),
   'cn' => $T_('China'),
   'co' => $T_('Colombia'),
   'km' => $T_('Comoros'),
   'cg' => $T_('Congo-Brazzaville'),
   'cd' => $T_('Congo-Kinshasa'),
   'cr' => $T_('Costa Rica'),
   'ci' => $T_('Ivory Coast'),
   'hr' => $T_('Croatia'),
   'cu' => $T_('Cuba'),
   'cy' => $T_('Cyprus'),
   'cz' => $T_('Czech Republic'),
   'dk' => $T_('Denmark'),
   'dj' => $T_('Djibouti'),
   'dm' => $T_('Dominica'),
   'do' => $T_('Dominican Republic'),
   'tp' => $T_('East Timor'),
   'ec' => $T_('Ecuador'),
   'eg' => $T_('Egypt'),
   'sv' => $T_('El Salvador'),
   'gq' => $T_('Equatorial Guinea'),
   'er' => $T_('Eritrea'),
   'eo' => $T_('Esperanto'),
   'ee' => $T_('Estonia'),
   'et' => $T_('Ethiopia'),
   //'eu' => $T_//('Europe'),//not a nation
   'fj' => $T_('Fiji'),
   'fi' => $T_('Finland'),
   'fr' => $T_('France'),
   'ga' => $T_('Gabon'),
   'gm' => $T_('Gambia'),
   'ge' => $T_('Georgia'),
   'de' => $T_('Germany'),
   'gh' => $T_('Ghana'),
   'gr' => $T_('Greece'),
   'gd' => $T_('Grenada'),
   'gt' => $T_('Guatemala'),
   'gn' => $T_('Guinea'),
   'gw' => $T_('Guinea-Bissau'),
   'gy' => $T_('Guyana'),
   'ht' => $T_('Haiti'),
   'hn' => $T_('Honduras'),
   'hk' => $T_('Hong Kong'),
   'hu' => $T_('Hungary'),
   'is' => $T_('Iceland'),
   'in' => $T_('India'),
   'id' => $T_('Indonesia'),
   'ia' => $T_('Interlingua'),
   'ir' => $T_('Iran'),
   'iq' => $T_('Iraq'),
   'ie' => $T_('Ireland'),
   'il' => $T_('Israel'),
   'it' => $T_('Italy'),
   'jm' => $T_('Jamaica'),
   'jp' => $T_('Japan'),
   'jo' => $T_('Jordan'),
   'kz' => $T_('Kazakstan'),
   'ke' => $T_('Kenya'),
   'ki' => $T_('Kiribati'),
   'kp' => $T_('Korea,North'),
   'kr' => $T_('Korea,South'),
   'kw' => $T_('Kuwait'),
   'kg' => $T_('Kyrgyzstan'),
   'la' => $T_('Laos'),
   'lv' => $T_('Latvia'),
   'lb' => $T_('Lebanon'),
   'ls' => $T_('Lesotho'),
   'lr' => $T_('Liberia'),
   'ly' => $T_('Libya'),
   'li' => $T_('Liechtenstein'),
   'lt' => $T_('Lithuania'),
   'lu' => $T_('Luxembourg'),
   'mo' => $T_('Macau'),
   'mk' => $T_('Macedonia'),
   'mg' => $T_('Madagascar'),
   'mw' => $T_('Malawi'),
   'my' => $T_('Malaysia'),
   'mv' => $T_('Maldives'),
   'ml' => $T_('Mali'),
   'mt' => $T_('Malta'),
   'mh' => $T_('Marshall Islands'),
   'mr' => $T_('Mauritania'),
   'mu' => $T_('Mauritius'),
   'mx' => $T_('Mexico'),
   'fm' => $T_('Micronesia'),
   'md' => $T_('Moldova'),
   'mc' => $T_('Monaco'),
   'mn' => $T_('Mongolia'),
   'mj' => $T_('Montenegro'),
   'ma' => $T_('Morocco'),
   'mz' => $T_('Mozambique'),
   'mm' => $T_('Myanmar'),
   'na' => $T_('Namibia'),
   'nr' => $T_('Nauru'),
   'np' => $T_('Nepal'),
   'nl' => $T_('Netherlands'),
   'nz' => $T_('New Zealand'),
   'ni' => $T_('Nicaragua'),
   'ne' => $T_('Niger'),
   'ng' => $T_('Nigeria'),
   'no' => $T_('Norway'),
   'om' => $T_('Oman'),
   'pk' => $T_('Pakistan'),
   'pw' => $T_('Palau'),
   'ps' => $T_('Palestinian Authority'),
   'pa' => $T_('Panama'),
   'pg' => $T_('Papua New Guinea'),
   'py' => $T_('Paraguay'),
   'pe' => $T_('Peru'),
   'ph' => $T_('Philippines'),
   'pl' => $T_('Poland'),
   'pt' => $T_('Portugal'),
   'pr' => $T_('Puerto Rico'),
   'qa' => $T_('Qatar'),
   'ro' => $T_('Romania'),
   'ru' => $T_('Russia'),
   'rw' => $T_('Rwanda'),
   'kn' => $T_('Saint Kitts and Nevis'),
   'lc' => $T_('Saint Lucia'),
   'vc' => $T_('Saint Vincent and the Grenadines'),
   'ws' => $T_('Samoa'),
   'sm' => $T_('San Marino'),
   'st' => $T_('Sao Tome and Principe'),
   'sa' => $T_('Saudi Arabia'),
   'sn' => $T_('Senegal'),
   //'yu' => $T_//('Serbia and Montenegro (Yugoslavia)'),//obsolet
   'rs' => $T_('Serbia'),
   'sc' => $T_('Seychelles'),
   'sl' => $T_('Sierra Leone'),
   'sg' => $T_('Singapore'),
   'sk' => $T_('Slovakia'),
   'si' => $T_('Slovenia'),
   'sb' => $T_('Solomon Islands'),
   'so' => $T_('Somalia'),
   'za' => $T_('South Africa'),
   'es' => $T_('Spain'),
   'lk' => $T_('Sri Lanka'),
   'sd' => $T_('Sudan'),
   'sr' => $T_('Suriname'),
   'sz' => $T_('Swaziland'),
   'se' => $T_('Sweden'),
   'ch' => $T_('Switzerland'),
   'sy' => $T_('Syria'),
   'tw' => $T_('Taiwan'),
   'tj' => $T_('Tajikistan'),
   'tz' => $T_('Tanzania'),
   'th' => $T_('Thailand'),
   'tg' => $T_('Togo'),
   'to' => $T_('Tonga'),
   'tt' => $T_('Trinidad and Tobago'),
   'tn' => $T_('Tunisia'),
   'tr' => $T_('Turkey'),
   'tm' => $T_('Turkmenistan'),
   'tv' => $T_('Tuvalu'),
   'ug' => $T_('Uganda'),
   'ua' => $T_('Ukraine'),
   'ae' => $T_('United Arab Emirates'),
   'gb' => $T_('United Kingdom'),
   'us' => $T_('United States'),
   'uy' => $T_('Uruguay'),
   'uz' => $T_('Uzbekistan'),
   'vu' => $T_('Vanuatu'),
   'va' => $T_('Vatican City State (Holy See)'),
   've' => $T_('Venezuela'),
   'vn' => $T_('Vietnam'),
   'ye' => $T_('Yemen'),
   'zm' => $T_('Zambia'),
   'zw' => $T_('Zimbabwe'),
   '__' => $T_('Earth'),
  );
?>
